Index: branches/dev_001_GM/NEMO/OPA_SRC/TRD/trdicp.F90
===================================================================
--- branches/dev_001_GM/NEMO/OPA_SRC/TRD/trdicp.F90	(revision 786)
+++ branches/dev_001_GM/NEMO/OPA_SRC/TRD/trdicp.F90	(revision 790)
@@ -663,24 +690,22 @@
 
 
-         IF(lwp) THEN
             WRITE (numout,*)
             WRITE (numout,*)
             WRITE (numout,9440) kt
-            WRITE (numout,9441) ( tmo(jpicpt_xad)+tmo(jpicpt_yad)+tmo(jpicpt_zad) )/tvolt,   &
-            &                   ( smo(jpicpt_xad)+smo(jpicpt_yad)+smo(jpicpt_zad) )/tvolt
-            WRITE (numout,9442)   tmo(jpicpt_zl1)/tvolt,  smo(jpicpt_zl1)/tvolt
-            WRITE (numout,9443)   tmo(jpicpt_ldf)/tvolt,  smo(jpicpt_ldf)/tvolt
-            WRITE (numout,9444)   tmo(jpicpt_zdf)/tvolt,  smo(jpicpt_zdf)/tvolt
-            WRITE (numout,9445)   tmo(jpicpt_npc)/tvolt,  smo(jpicpt_npc)/tvolt
-            WRITE (numout,9446) ( t2(jpicpt_xad)+t2(jpicpt_yad)+t2(jpicpt_zad) )/tvolt,    &
-            &                   ( s2(jpicpt_xad)+s2(jpicpt_yad)+s2(jpicpt_zad) )/tvolt
-            WRITE (numout,9447)   t2(jpicpt_ldf)/tvolt,   s2(jpicpt_ldf)/tvolt
-            WRITE (numout,9448)   t2(jpicpt_zdf)/tvolt,   s2(jpicpt_zdf)/tvolt
-            WRITE (numout,9449)   t2(jpicpt_npc)/tvolt,   s2(jpicpt_npc)/tvolt
-         ENDIF
-
-9440     FORMAT(' tracer consistency at it= ',i6,   &
-            ' :         temperature','                salinity',/,   &
-            ' ==================================')
+            WRITE (numout,9441) ( tsmo(jpt_trd_xad,jp_tem)+tsmo(jpt_trd_yad,jp_tem)+tsmo(jpt_trd_zad,jp_tem) )/tvolt,  &
+            &                   ( tsmo(jpt_trd_xad,jp_sal)+tsmo(jpt_trd_yad,jp_sal)+tsmo(jpt_trd_zad,jp_sal) )/tvolt
+            WRITE (numout,9442)   tsmo(jpt_trd_zl1,jp_tem)/tvolt,  tsmo(jpt_trd_zl1,jp_sal)/tvolt
+            WRITE (numout,9443)   tsmo(jpt_trd_ldf,jp_tem)/tvolt,  tsmo(jpt_trd_ldf,jp_sal)/tvolt
+            WRITE (numout,9444)   tsmo(jpt_trd_zdf,jp_tem)/tvolt,  tsmo(jpt_trd_zdf,jp_sal)/tvolt
+            WRITE (numout,9445)   tsmo(jpt_trd_npc,jp_tem)/tvolt,  tsmo(jpt_trd_npc,jp_sal)/tvolt
+            WRITE (numout,9446) ( ts2(jpt_trd_xad,jp_tem)+ts2(jpt_trd_yad,jp_tem)+ts2(jpt_trd_zad,jp_tem) )/tvolt,    &
+            &                   ( ts2(jpt_trd_xad,jp_sal)+ts2(jpt_trd_yad,jp_sal)+ts2(jpt_trd_zad,jp_sal) )/tvolt
+            WRITE (numout,9447)   ts2(jpt_trd_ldf,jp_tem)/tvolt,   ts2(jpt_trd_ldf,jp_sal)/tvolt
+            WRITE (numout,9448)   ts2(jpt_trd_zdf,jp_tem)/tvolt,   ts2(jpt_trd_zdf,jp_sal)/tvolt
+            WRITE (numout,9449)   ts2(jpt_trd_npc,jp_tem)/tvolt,   ts2(jpt_trd_npc,jp_sal)/tvolt
+         ENDIF
+
+9440     FORMAT(' tracer consistency at it= ',i6, ' :         temperature','                salinity',   &
+                /, ' ==================================')
 9441     FORMAT(' 0 = horizontal+vertical advection +    ',e20.13,'       ',e20.13)
 9442     FORMAT('     1st lev vertical advection         ',e20.13,'       ',e20.13)
Index: branches/dev_001_GM/NEMO/OPA_SRC/TRD/trdicp_oce.F90
===================================================================
--- branches/dev_001_GM/NEMO/OPA_SRC/TRD/trdicp_oce.F90	(revision 786)
+++ branches/dev_001_GM/NEMO/OPA_SRC/TRD/trdicp_oce.F90	(revision 790)
@@ -14,38 +14,4 @@
    PUBLIC
 
-   !! * Shared module variables
-#if  defined key_trdtra   &&   defined key_trddyn    ||   defined key_esopa
-   LOGICAL, PARAMETER ::   lk_trdtra = .TRUE.    !: tracers  trend flag
-   LOGICAL, PARAMETER ::   lk_trddyn = .TRUE.    !: momentum trend flag
-#elif  defined key_trdtra
-   LOGICAL, PARAMETER ::   lk_trdtra = .TRUE.    !: tracers  trend flag
-   LOGICAL, PARAMETER ::   lk_trddyn = .FALSE.   !: momentum trend flag
-#elif  defined key_trddyn
-   LOGICAL, PARAMETER ::   lk_trdtra = .FALSE.   !: tracers  trend flag
-   LOGICAL, PARAMETER ::   lk_trddyn = .TRUE.    !: momentum trend flag
-#else
-   LOGICAL, PARAMETER ::   lk_trdtra = .FALSE.   !: tracers  trend flag
-   LOGICAL, PARAMETER ::   lk_trddyn = .FALSE.   !: momentum trend flag
-#endif
-
-   !! Tracers trends diagnostics parameters
-   !!---------------------------------------------------------------------
-   INTEGER, PARAMETER ::   &  !: => tracer trends indexes <=
-        jpicpt_xad =  1,   &  !: x- horizontal advection
-        jpicpt_yad =  2,   &  !: y- horizontal advection
-        jpicpt_zad =  3,   &  !: z- vertical   advection
-        jpicpt_ldf =  4,   &  !: lateral       diffusion
-        jpicpt_zdf =  5,   &  !: vertical diffusion (Kz)
-        jpicpt_bbc =  6,   &  !: Bottom Boundary Condition (geoth. flux) 
-        jpicpt_bbl =  7,   &  !: Bottom Boundary Layer (diffusive/convective)
-        jpicpt_npc =  8,   &  !: static instability mixing
-        jpicpt_dmp =  9,   &  !: damping
-        jpicpt_qsr = 10,   &  !: penetrative solar radiation
-        jpicpt_nsr = 11,   &  !: non solar radiation
-        jpicpt_zl1 = 12       !: first level vertical flux
-
-   INTEGER, PARAMETER ::   &  !: => Total tracer trends indexes <=
-        jptot_tra = 12        !: change it when adding/removing one indice above
-   
    !! Momentum trends diagnostics parameters
    !!---------------------------------------------------------------------
@@ -66,25 +32,4 @@
         jptot_dyn = 11        !: change it when adding/removing one indice above
    
-#if   defined key_trdtra   ||   defined key_trddyn   ||   defined key_esopa
-
-   !! Variables used for diagnostics
-   !!---------------------------------------------------------------------
-   REAL(wp) ::   tvolt        !: volume of the whole ocean computed at t-points
-   REAL(wp) ::   tvolu        !: volume of the whole ocean computed at u-points
-   REAL(wp) ::   tvolv        !: volume of the whole ocean computed at v-points
-
-   !! Tracers trends diagnostics variables
-   !!---------------------------------------------------------------------
-   REAL(wp), DIMENSION(jptot_tra) ::   tmo, smo         !: tracers trends average 
-   REAL(wp), DIMENSION(jptot_tra) ::   t2, s2           !: tracers square trends average 
-   
-   !! Momentum trends diagnostics variables
-   !!---------------------------------------------------------------------
-   REAL(wp), DIMENSION(jptot_dyn) ::   umo, vmo         !: momentum trends average 
-   REAL(wp), DIMENSION(jptot_dyn) ::   hke              !: momentum square trends average 
-   REAL(wp) ::   rpktrd   !: potential to kinetic energy conversion
-   REAL(wp) ::   peke     !: conversion potential energy - kinetic energy trend
-
-#endif
    !!----------------------------------------------------------------------
    !!  OPA 9.0 , LOCEAN-IPSL (2005) 
Index: branches/dev_001_GM/NEMO/OPA_SRC/TRD/trdmod.F90
===================================================================
--- branches/dev_001_GM/NEMO/OPA_SRC/TRD/trdmod.F90	(revision 786)
+++ branches/dev_001_GM/NEMO/OPA_SRC/TRD/trdmod.F90	(revision 790)
@@ -9,5 +9,7 @@
 #if  defined key_trdtra || defined key_trddyn || defined key_trdmld || defined key_trdvor || defined key_esopa
    !!----------------------------------------------------------------------
-   !!   trd_mod          : Call the trend to be computed
+   !!   trd_tra          : active tracer trend manager
+   !!   trd_tra_adv      : pre-treatment of the tracer advection trends
+   !!   trd_mod          : momentum trend manager
    !!   trd_mod_init     : Initialization step
    !!----------------------------------------------------------------------
@@ -29,5 +31,7 @@
    REAL(wp) ::   r2dt          ! time-step, = 2 rdttra except at nit000 (=rdttra) if neuler=0
 
-   PUBLIC trd_mod              ! called by all dynXX or traXX modules
+   PUBLIC trd_tra              ! called by all traXXX.F90 modules
+   PUBLIC trd_tra_adv          ! called by all traadv_XXX.F90 modules
+   PUBLIC trd_mod              ! called by all dynXXX.F90 modules
    PUBLIC trd_mod_init         ! called by opa.F90 module
 
@@ -42,4 +46,221 @@
 
 CONTAINS
+
+   SUBROUTINE trd_tra( kt, ktra, ktrd, ctype, ptrd2d, ptrd3d, cnbpas )
+      !!---------------------------------------------------------------------
+      !!                  ***  ROUTINE trd_mod  ***
+      !! 
+      !! ** Purpose : Dispatch all trends computation, e.g. vorticity, mld or 
+      !!              integral constraints
+      !!----------------------------------------------------------------------
+      INTEGER         , INTENT(in   )                                   ::   kt      ! time step
+      INTEGER         , INTENT(in   )                                   ::   ktra    ! tracer index
+      INTEGER         , INTENT(in   )                                   ::   ktrd    ! tracer trend index
+      CHARACTER(len=3), INTENT(in   )                                   ::   ctype   ! tracers type 'TRA' or 'TRC'
+      REAL(wp)        , INTENT(inout), DIMENSION(jpi,jpj)    , OPTIONAL ::   ptrd2d  ! Temperature or U trend 
+      REAL(wp)        , INTENT(inout), DIMENSION(jpi,jpj,jpk), OPTIONAL ::   ptrd3d  ! Temperature or U trend 
+      CHARACTER(len=3), INTENT(in   )                        , OPTIONAL ::   cnbpas  ! number of passage
+      !!
+      CHARACTER(len=3) ::   ccpas                                  ! number of passage
+!     REAL(wp), DIMENSION(jpi,jpj) ::   z2dx, z2dy                 ! workspace arrays
+      !!----------------------------------------------------------------------
+
+      ccpas = 'fst'                            ! Control of optional arguments
+      IF( PRESENT(cnbpas) )  ccpas = cnbpas
+
+      IF( neuler == 0 .AND. kt == nit000    ) THEN   ;   r2dt =      rdt      ! = rdtra (restarting with Euler time stepping)
+      ELSEIF(               kt <= nit000 + 1) THEN   ;   r2dt = 2. * rdt      ! = 2 rdttra (leapfrog)
+      ENDIF
+
+      !>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
+      ! I. Integral Constraints Properties for momentum and/or tracers trends
+      !<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
+
+      IF( ( mod(kt,ntrd) == 0 .OR. kt == nit000 .OR. kt == nitend) )   THEN
+         !
+         IF( lk_trdtra .AND. ctype == 'TRA' )   THEN       ! active tracer trends
+            IF( PRESENT(ptrd2d) ) THEN   ;   CALL trd_icp( ptrd2d, ktra, ktrd, ctype, clpas=ccpas )
+            ELSE                         ;   CALL trd_icp( ptrd3d, ktra, ktrd, ctype, clpas=ccpas )
+            ENDIF
+         ENDIF
+!           SELECT CASE ( ktrd )
+!           CASE ( jptra_trd_ldf )   ;   CALL trd_icp( ptrdx, ptrdy, jpicpt_ldf, ctype )   ! lateral diff
+!           CASE ( jptra_trd_zdf )   ;   CALL trd_icp( ptrdx, ptrdy, jpicpt_zdf, ctype )   ! vertical diff (Kz)
+!           CASE ( jptra_trd_bbc )   ;   CALL trd_icp( ptrdx, ptrdy, jpicpt_bbc, ctype )   ! bottom boundary cond
+!           CASE ( jptra_trd_bbl )   ;   CALL trd_icp( ptrdx, ptrdy, jpicpt_bbl, ctype )   ! bottom boundary layer
+!           CASE ( jptra_trd_npc )   ;   CALL trd_icp( ptrdx, ptrdy, jpicpt_npc, ctype )   ! static instability mixing
+!           CASE ( jptra_trd_dmp )   ;   CALL trd_icp( ptrdx, ptrdy, jpicpt_dmp, ctype )   ! damping
+!           CASE ( jptra_trd_qsr )   ;   CALL trd_icp( ptrdx, ptrdy, jpicpt_qsr, ctype )   ! penetrative solar radiat.
+!           CASE ( jptra_trd_nsr )   
+!              z2dx(:,:) = ptrdx(:,:,1)   ;   z2dy(:,:) = ptrdy(:,:,1)
+!              CALL trd_icp( z2dx, z2dy, jpicpt_nsr, ctype )                               ! non solar radiation
+!           CASE ( jptra_trd_xad )   ;   CALL trd_icp( ptrdx, ptrdy, jpicpt_xad, ctype )   ! x- horiz adv
+!           CASE ( jptra_trd_yad )   ;   CALL trd_icp( ptrdx, ptrdy, jpicpt_yad, ctype )   ! y- horiz adv
+!           CASE ( jptra_trd_zad )   ;   CALL trd_icp( ptrdx, ptrdy, jpicpt_zad, ctype, clpas=ccpas )    ! z- adv 
+!              CALL trd_icp( ptrdx, ptrdy, jpicpt_zad, ctype, clpas=ccpas )   
+!              ! compute the surface flux condition wn(:,:,1)*tn(:,:,1)
+!              z2dx(:,:) = wn(:,:,1)*tn(:,:,1)/fse3t(:,:,1)
+!              z2dy(:,:) = wn(:,:,1)*sn(:,:,1)/fse3t(:,:,1)
+!              CALL trd_icp( z2dx , z2dy , jpicpt_zl1, ctype )                             ! 1st z- vertical adv 
+!           END SELECT
+!        END IF
+         !
+      END IF
+
+      !>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
+      ! III. Mixed layer trends for active tracers
+      !<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
+
+      IF( lk_trdmld .AND. ctype == 'TRA' )   THEN
+         
+         !-----------------------------------------------------------------------------------------------
+         ! W.A.R.N.I.N.G :
+         ! jptra_trd_ldf : called by traldf.F90
+         !                 at this stage we store:
+         !                  - the lateral geopotential diffusion (here, lateral = horizontal)
+         !                  - and the iso-neutral diffusion if activated 
+         ! jptra_trd_zdf : called by trazdf.F90
+         !                 * in case of iso-neutral diffusion we store the vertical diffusion component in the 
+         !                   lateral trend including the K_z contrib, which will be removed later (see trd_mld)
+         !-----------------------------------------------------------------------------------------------
+
+!        SELECT CASE ( ktrd )
+!        CASE ( jpt_trd_zdf )
+!           IF( ln_traldf_iso )   THEN
+!              CALL trd_mld_zint( ptrdx, ptrdy, jpmld_ldf, '3D' )   ! vertical diffusion (K_z)
+!           ELSE
+!              CALL trd_mld_zint( ptrdx, ptrdy, jpmld_zdf, '3D' )   ! vertical diffusion (K_z)
+!           ENDIF
+!        CASE ( jpt_trd_nsr )
+!           ptrdx(:,:,2:jpk) = 0.e0   ;   ptrdy(:,:,2:jpk) = 0.e0
+!           CALL trd_mld_zint( ptrdx, ptrdy, jpmld_for, '2D' )                             ! air-sea : non solar flux
+!        CASE ( jpt_trd_bbc )   ;   CALL trd_mld_zint( ptrdx, ptrdy, jpmld_bbc, '3D' )   ! bbc (geothermal flux)
+!        CASE DEFAULT
+!                                     CALL trd_mld_zint( ptrdx, ptrdy, ktra     , '3D' )   ! other 3D trends
+!        END SELECT
+
+      ENDIF
+
+   END SUBROUTINE trd_tra
+
+
+   SUBROUTINE trd_tra_adv( kt, ktra, ktrd, ctype, pf, pun, ptn, cnbpas )
+      !!---------------------------------------------------------------------
+      !!                  ***  ROUTINE trd_mod  ***
+      !! 
+      !! ** Purpose :   transformed the i-advective flux into the i-advective trends
+      !! ** Method  :   i-advective trends = un. di[T] = di[fi] - tn di[un]
+      !!----------------------------------------------------------------------
+      INTEGER         , INTENT(in   )                         ::   kt      ! time step
+      INTEGER         , INTENT(in   )                         ::   ktra    ! tracer index
+      INTEGER         , INTENT(in   )                         ::   ktrd    ! tracer trend index
+      CHARACTER(len=3), INTENT(in   )                         ::   ctype   ! tracers type 'TRA' or 'TRC'
+      REAL(wp)        , INTENT(in   ), DIMENSION(jpi,jpj,jpk) ::   pf      ! advective flux in one direction
+      REAL(wp)        , INTENT(in   ), DIMENSION(jpi,jpj,jpk) ::   pun     ! now velocity  in one direction
+      REAL(wp)        , INTENT(in   ), DIMENSION(jpi,jpj,jpk) ::   ptn     ! now or before tracer 
+      CHARACTER(len=3), INTENT(in   )                        , OPTIONAL ::   cnbpas  ! number of passage
+      !!
+      INTEGER                          ::   ji, jj, jk      ! dummy loop indices
+      CHARACTER(len=3) ::   ccpas                           ! number of passage
+      REAL(wp)                         ::   zbtr, z_hdivn   ! 
+      REAL(wp), DIMENSION(jpi,jpj,jpk) ::   ztrdt           ! 3D workspace 
+      !!----------------------------------------------------------------------
+
+      ccpas = 'fst'                            ! Control of optional arguments
+      IF( PRESENT(cnbpas) )  ccpas = cnbpas
+
+      ztrdt(:,:,:) = 0.e0
+      !
+      IF( ccpas == 'fst' ) THEN      ! first treatment : remove the divergence
+         SELECT CASE( ktrd ) 
+         CASE( jpt_trd_xad )      ! i-advective trend
+            DO jk = 1, jpkm1
+               DO jj = 2, jpjm1
+                  DO ji = fs_2, fs_jpim1   ! vector opt.
+#if defined key_zco
+                     zbtr    = 1.e0 / ( e1t(ji,jj) * e2t(ji,jj) )
+                     z_hdivn = (  e2u(ji  ,jj) * pun(ji  ,jj,jk)                              &
+                        &       - e2u(ji-1,jj) * pun(ji-1,jj,jk) )
+#else
+                     zbtr    = 1.e0/ ( e1t(ji,jj) * e2t(ji,jj) * fse3t(ji,jj,jk) )
+                     z_hdivn = (  e2u(ji  ,jj) * fse3u(ji  ,jj,jk) * pun(ji  ,jj,jk)          &
+                        &       - e2u(ji-1,jj) * fse3u(ji-1,jj,jk) * pun(ji-1,jj,jk) )
+#endif
+                     ztrdt(ji,jj,jk) = - zbtr * (  pf(ji,jj,jk) - pf(ji-1,jj,jk)  -  ptn(ji,jj,jk) * z_hdivn  )
+                  END DO
+               END DO
+            END DO
+            !
+         CASE( jpt_trd_yad )      ! j-advective trend
+            DO jk = 1, jpkm1
+               DO jj = 2, jpjm1
+                  DO ji = fs_2, fs_jpim1   ! vector opt.
+#if defined key_zco
+                     zbtr    = 1.e0 / ( e1t(ji,jj) * e2t(ji,jj) )
+                     z_hdivn = (  e1v(ji,jj  ) * pun(ji,jj  ,jk)                              &
+                        &       - e1v(ji,jj-1) * pun(ji,jj-1,jk) )
+#else
+                     zbtr    = 1.e0/ ( e1t(ji,jj) * e2t(ji,jj) * fse3t(ji,jj,jk) )
+                     z_hdivn = (  e1v(ji  ,jj) * fse3v(ji,jj  ,jk) * pun(ji,jj  ,jk)          &
+                        &       - e1v(ji-1,jj) * fse3v(ji,jj-1,jk) * pun(ji,jj-1,jk) )
+#endif
+                     ztrdt(ji,jj,jk) = - zbtr * (  pf(ji,jj,jk) - pf(ji,jj-1,jk)  -  ptn(ji,jj,jk) * z_hdivn  )
+                  END DO
+               END DO
+            END DO
+            !
+         CASE( jpt_trd_zad )      ! z-advective trend
+            DO jk = 1, jpkm1
+               DO jj = 2, jpjm1
+                  DO ji = fs_2, fs_jpim1   ! vector opt.
+                     zbtr    = 1.e0 / fse3t(ji,jj,jk)
+                     z_hdivn = pun(ji,jj,jk) - pun(ji,jj,jk+1)
+                     ztrdt(ji,jj,jk) = - zbtr * (  pf(ji,jj,jk) - pf(ji,jj,jk+1)  -  ptn(ji,jj,jk) * z_hdivn  )
+                  END DO
+               END DO
+            END DO
+            !
+         END SELECT
+         !
+      ELSE                ! second call : just compute the trend   (TVD scheme)
+         SELECT CASE( ktrd ) 
+         CASE( jpt_trd_xad )      ! i-advective trend
+            DO jk = 1, jpkm1      
+               DO jj = 2, jpjm1
+                  DO ji = fs_2, fs_jpim1   ! vector opt.
+                     zbtr    = 1.e0 / ( e1t(ji,jj) * e2t(ji,jj) * fse3t(ji,jj,jk) )
+                     ztrdt(ji,jj,jk) = - zbtr * (  pf(ji,jj,jk) - pf(ji-1,jj,jk)  )
+                  END DO
+               END DO
+            END DO
+            !
+         CASE( jpt_trd_yad )      ! j-advective trend
+            DO jk = 1, jpkm1
+               DO jj = 2, jpjm1
+                  DO ji = fs_2, fs_jpim1   ! vector opt.
+                     zbtr    = 1.e0 / ( e1t(ji,jj) * e2t(ji,jj) * fse3t(ji,jj,jk) )
+                     ztrdt(ji,jj,jk) = - zbtr * (  pf(ji,jj,jk) - pf(ji,jj-1,jk)  )
+                  END DO
+               END DO
+            END DO
+            !
+         CASE( jpt_trd_zad )      ! z-advective trend
+            DO jk = 1, jpkm1
+               DO jj = 2, jpjm1
+                  DO ji = fs_2, fs_jpim1   ! vector opt.
+                     zbtr    = 1.e0 / fse3t(ji,jj,jk)
+                     ztrdt(ji,jj,jk) = - zbtr * (  pf(ji,jj,jk) - pf(ji,jj,jk+1)  )
+                  END DO
+               END DO
+            END DO
+            !
+         END SELECT
+         !
+      ENDIF
+      !
+      CALL trd_tra( kt, ktra, ktrd, ctype, ptrd3d=ztrdt)       ! trend diagnostics
+      !
+   END SUBROUTINE trd_tra_adv
+
 
    SUBROUTINE trd_mod( ptrdx, ptrdy, ktrd, ctype, kt, cnbpas )
@@ -50,10 +271,10 @@
       !!              integral constraints
       !!----------------------------------------------------------------------
-      INTEGER, INTENT( in ) ::   kt                                ! time step
-      INTEGER, INTENT( in ) ::   ktrd                              ! tracer trend index
-      CHARACTER(len=3), INTENT( in ) ::   ctype                    ! momentum or tracers trends type 'DYN'/'TRA'
-      CHARACTER(len=3), INTENT( in ), OPTIONAL ::   cnbpas         ! number of passage
-      REAL(wp), DIMENSION(jpi,jpj,jpk), INTENT( inout ) ::   ptrdx ! Temperature or U trend 
-      REAL(wp), DIMENSION(jpi,jpj,jpk), INTENT( inout ) ::   ptrdy ! Salinity    or V trend
+      INTEGER         , INTENT(in   )                                   ::   kt      ! time step
+      INTEGER         , INTENT(in   )                                   ::   ktrd    ! tracer trend index
+      CHARACTER(len=3), INTENT(in   )                                   ::   ctype   ! momentum trends type ='DYN'
+      CHARACTER(len=3), INTENT(in   )                        , OPTIONAL ::   cnbpas  ! number of passage
+      REAL(wp)        , INTENT(inout), DIMENSION(jpi,jpj,jpk)           ::   ptrdx   ! Temperature or U trend 
+      REAL(wp)        , INTENT(inout), DIMENSION(jpi,jpj,jpk)           ::   ptrdy   ! Salinity    or V trend
       !!
       INTEGER ::   ji, ikbu, ikbum1
@@ -68,9 +289,8 @@
       z2dx(:,:)   = 0.e0   ;   z2dy(:,:)   = 0.e0                  ! initialization of workspace arrays
 
-      ! Control of optional arguments
-      ccpas = 'fst'
+      ccpas = 'fst'                            ! Control of optional arguments
       IF( PRESENT(cnbpas) )  ccpas = cnbpas
 
-      IF( neuler == 0 .AND. kt == nit000    ) THEN   ;   r2dt =      rdt      ! = rdtra (restarting with Euler time stepping)
+      IF( neuler == 0 .AND. kt == nit000    ) THEN   ;   r2dt =      rdt      ! = rdtra (start with Euler time stepping)
       ELSEIF(               kt <= nit000 + 1) THEN   ;   r2dt = 2. * rdt      ! = 2 rdttra (leapfrog)
       ENDIF
@@ -82,27 +302,4 @@
       IF( ( mod(kt,ntrd) == 0 .OR. kt == nit000 .OR. kt == nitend) )   THEN
          !
-         IF( lk_trdtra .AND. ctype == 'TRA' )   THEN       ! active tracer trends
-            SELECT CASE ( ktrd )
-            CASE ( jptra_trd_ldf )   ;   CALL trd_icp( ptrdx, ptrdy, jpicpt_ldf, ctype )   ! lateral diff
-            CASE ( jptra_trd_zdf )   ;   CALL trd_icp( ptrdx, ptrdy, jpicpt_zdf, ctype )   ! vertical diff (Kz)
-            CASE ( jptra_trd_bbc )   ;   CALL trd_icp( ptrdx, ptrdy, jpicpt_bbc, ctype )   ! bottom boundary cond
-            CASE ( jptra_trd_bbl )   ;   CALL trd_icp( ptrdx, ptrdy, jpicpt_bbl, ctype )   ! bottom boundary layer
-            CASE ( jptra_trd_npc )   ;   CALL trd_icp( ptrdx, ptrdy, jpicpt_npc, ctype )   ! static instability mixing
-            CASE ( jptra_trd_dmp )   ;   CALL trd_icp( ptrdx, ptrdy, jpicpt_dmp, ctype )   ! damping
-            CASE ( jptra_trd_qsr )   ;   CALL trd_icp( ptrdx, ptrdy, jpicpt_qsr, ctype )   ! penetrative solar radiat.
-            CASE ( jptra_trd_nsr )   
-               z2dx(:,:) = ptrdx(:,:,1)   ;   z2dy(:,:) = ptrdy(:,:,1)
-               CALL trd_icp( z2dx, z2dy, jpicpt_nsr, ctype )                               ! non solar radiation
-            CASE ( jptra_trd_xad )   ;   CALL trd_icp( ptrdx, ptrdy, jpicpt_xad, ctype )   ! x- horiz adv
-            CASE ( jptra_trd_yad )   ;   CALL trd_icp( ptrdx, ptrdy, jpicpt_yad, ctype )   ! y- horiz adv
-            CASE ( jptra_trd_zad )                                                         ! z- vertical adv 
-               CALL trd_icp( ptrdx, ptrdy, jpicpt_zad, ctype, clpas=ccpas )   
-               ! compute the surface flux condition wn(:,:,1)*tn(:,:,1)
-               z2dx(:,:) = wn(:,:,1)*tn(:,:,1)/fse3t(:,:,1)
-               z2dy(:,:) = wn(:,:,1)*sn(:,:,1)/fse3t(:,:,1)
-               CALL trd_icp( z2dx , z2dy , jpicpt_zl1, ctype )                             ! 1st z- vertical adv 
-            END SELECT
-         END IF
-
          IF( lk_trddyn .AND. ctype == 'DYN' )   THEN       ! momentum trends 
             !
@@ -200,46 +397,5 @@
          !
       ENDIF
-
-      !>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>
-      ! III. Mixed layer trends for active tracers
-      !<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
-
-      IF( lk_trdmld .AND. ctype == 'TRA' )   THEN
-         
-         !-----------------------------------------------------------------------------------------------
-         ! W.A.R.N.I.N.G :
-         ! jptra_trd_ldf : called by traldf.F90
-         !                 at this stage we store:
-         !                  - the lateral geopotential diffusion (here, lateral = horizontal)
-         !                  - and the iso-neutral diffusion if activated 
-         ! jptra_trd_zdf : called by trazdf.F90
-         !                 * in case of iso-neutral diffusion we store the vertical diffusion component in the 
-         !                   lateral trend including the K_z contrib, which will be removed later (see trd_mld)
-         !-----------------------------------------------------------------------------------------------
-
-         SELECT CASE ( ktrd )
-         CASE ( jptra_trd_xad )   ;   CALL trd_mld_zint( ptrdx, ptrdy, jpmld_xad, '3D' )   ! merid. advection
-         CASE ( jptra_trd_yad )   ;   CALL trd_mld_zint( ptrdx, ptrdy, jpmld_yad, '3D' )   ! zonal  advection
-         CASE ( jptra_trd_zad )   ;   CALL trd_mld_zint( ptrdx, ptrdy, jpmld_zad, '3D' )   ! vertical advection
-         CASE ( jptra_trd_ldf )   ;   CALL trd_mld_zint( ptrdx, ptrdy, jpmld_ldf, '3D' )   ! lateral diffusive
-         CASE ( jptra_trd_bbl )   ;   CALL trd_mld_zint( ptrdx, ptrdy, jpmld_bbl, '3D' )   ! bottom boundary layer
-         CASE ( jptra_trd_zdf )
-            IF( ln_traldf_iso )   THEN
-               CALL trd_mld_zint( ptrdx, ptrdy, jpmld_ldf, '3D' )   ! vertical diffusion (K_z)
-            ELSE
-               CALL trd_mld_zint( ptrdx, ptrdy, jpmld_zdf, '3D' )   ! vertical diffusion (K_z)
-            ENDIF
-         CASE ( jptra_trd_dmp )   ;   CALL trd_mld_zint( ptrdx, ptrdy, jpmld_dmp, '3D' )   ! internal 3D restoring (tradmp)
-         CASE ( jptra_trd_qsr )   ;   CALL trd_mld_zint( ptrdx, ptrdy, jpmld_for, '3D' )   ! air-sea : penetrative sol radiat
-         CASE ( jptra_trd_nsr )
-            ptrdx(:,:,2:jpk) = 0.e0   ;   ptrdy(:,:,2:jpk) = 0.e0
-            CALL trd_mld_zint( ptrdx, ptrdy, jpmld_for, '2D' )                             ! air-sea : non penetr sol radiat
-         CASE ( jptra_trd_bbc )   ;   CALL trd_mld_zint( ptrdx, ptrdy, jpmld_bbc, '3D' )   ! bottom bound cond (geoth flux)
-         CASE ( jptra_trd_atf )   ;   CALL trd_mld_zint( ptrdx, ptrdy, jpmld_atf, '3D' )   ! asselin numerical
-         CASE ( jptra_trd_npc )   ;   CALL trd_mld_zint( ptrdx, ptrdy, jpmld_npc, '3D' )   ! non penetr convect adjustment
-         END SELECT
-
-      ENDIF
-
+      !
    END SUBROUTINE trd_mod
 
@@ -254,10 +410,27 @@
 
 CONTAINS
+
+   SUBROUTINE trd_tra( kt, ktra, ktrd, ctype, ptrd2d, ptrd3d, cnbpas )
+      INTEGER ::   kt, ktra, ktrd
+      CHARACTER(len=3) ::   ctype   ! tracers type 'TRA' or 'TRC'
+      REAL, DIMENSION(:,:)  , OPTIONAL ::   ptrd2d  ! Temperature or U trend 
+      REAL, DIMENSION(:,:,:), OPTIONAL ::   ptrd3d  ! Temperature or U trend 
+      CHARACTER(len=3)      , OPTIONAL ::   cnbpas  ! number of passage
+      WRITE(*,*) 'trd_3d: You should not have seen this print! error ?', kt, ktra, ktrd, ctype,   &
+         &                                                               ptrd2d(1,1), ptrd3d(1,1,1), cnbpas
+   END SUBROUTINE trd_tra
+
+   SUBROUTINE trd_tra_adv( kt, ktra, ktrd, ctype, pf, pun, ptn, cnbpas )
+      INTEGER ::   kt, ktra, ktrd  
+      CHARACTER(len=3) ::   ctype
+      REAL, DIMENSION(:,:,:) ::   pf, pun, ptn
+      CHARACTER(len=3), OPTIONAL ::   cnbpas
+      WRITE(*,*) 'trd_3d: You should not have seen this print! error ?', kt, ktra, ktrd, ctype, pf(1,1,1),   &
+         &                                                               pun(1,1,1), ptn(1,1,1), cnbpas
+   END SUBROUTINE trd_tra_adv
+
    SUBROUTINE trd_mod(ptrd3dx, ptrd3dy, ktrd , ctype, kt, cnbpas)   ! Empty routine
-      REAL, DIMENSION(:,:,:), INTENT( in ) ::   &
-          ptrd3dx,                     &                           ! Temperature or U trend 
-          ptrd3dy                                                  ! Salinity    or V trend
-      INTEGER, INTENT( in ) ::   ktrd                              ! momentum or tracer trend index
-      INTEGER, INTENT( in ) ::   kt                                ! Time step
+      REAL, DIMENSION(:,:,:) ::   ptrd3dx, ptrd3dy    
+      INTEGER ::   ktrd, kt
       CHARACTER(len=3), INTENT( in ) ::  ctype                     ! momentum or tracers trends type
       CHARACTER(len=3), INTENT( in ), OPTIONAL ::   cnbpas         ! number of passage
